/*
 * Copyright (C) 2001-2011 Jacek Sieka, arnetheduck on gmail point com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef ABOUT_DLG_H
#define ABOUT_DLG_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "../client/HttpConnection.h"
#include "../client/SimpleXML.h"
#include "../client/TimerManager.h"

static const TCHAR thanks[] = _T("Dekuji za pomoc vsem kteri se na tomto programku podileli.\r\n")
_T("Nejvetsi diky patri Trpaslikovi za jeho barevny chat a spoustu dalsich veci ...\r\n")
_T("Dalsi velke diky pro createagaga ze velikou pomoc se vsim s cim sem si nevedel rady a zrejme by sem bez neho nedal dohromady.\r\n")
_T("Taky nesmim zapomenout podekovat Silbertovi a Sechmet za ikonky ;o)\r\n")
_T("A samozrejme diky i vsem ostatnim ktere tu jsem linej vyjmenovat :-D");

class AboutDlg : private HttpConnectionListener, private TimerManagerListener {
public:
	enum { WM_VERSIONDATA = WM_APP + 53 };
	enum Speakers { STATS_SECOND, STATS_MINUTE };

	AboutDlg() { m_hWnd = NULL; }
	~AboutDlg() { }

    static INT_PTR CALLBACK AboutDlgProc(HWND hWndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam);
    LRESULT AboutProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);

	void OnInitDialog();
	void onVersionData(WPARAM wParam);
	void OnCloseCmd(WORD wID);
	void onSpeaker(WPARAM wParam);
	void DoModal(HWND hWndParent);
private:
	HttpConnection c;

	void on(HttpConnectionListener::Data, HttpConnection* /*conn*/, const uint8_t* buf, size_t len) throw() {
		downBuf.append((char*)buf, len);
	}

	void on(HttpConnectionListener::Complete, HttpConnection* conn, const string&) throw();
	void on(HttpConnectionListener::Failed, HttpConnection* conn, const string& aLine) throw();
	void on(TimerManagerListener::Second, uint64_t) throw() { ::PostMessage(m_hWnd, WM_SPEAKER, STATS_SECOND, 0); }
	void on(TimerManagerListener::Minute, uint64_t) throw() { ::PostMessage(m_hWnd, WM_SPEAKER, STATS_MINUTE, 0); }

	string downBuf;

	HWND m_hWnd;
};

#endif // ABOUT_DLG_H

/*
 * Some parts Copyright (C) 2002-2011 Petr Kozelka, PPK at czdc dot org
 * Licensed under GNU General Public License version 3.
 */
