/*
 * Copyright (C) 2001-2011 Jacek Sieka, arnetheduck on gmail point com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "stdafx.h"
#include "../client/DCPlusPlus.h"
#include "Resource.h"

#include "AdvancedPage.h"
#include "CommandDlg.h"

#include "../client/SettingsManager.h"
#include "WinUtil.h"

AdvancedPage * pAdvancedPage = NULL;

AdvancedPage::AdvancedPage(SettingsManager *s) : PropPage(s, IDD_ADVANCEDPAGE) {
    pAdvancedPage = this;
	SetTitle(CTSTRING(SETTINGS_ADVANCED));
	m_psp.pfnDlgProc = (DLGPROC)AdvancedPageProc;
}

AdvancedPage::~AdvancedPage() {
    pAdvancedPage = NULL;
}

BOOL CALLBACK AdvancedPage::AdvancedPageProc(HWND hWnd, UINT uMsg, WPARAM /*wParam*/, LPARAM /*lParam*/) {
    if(uMsg == WM_INITDIALOG) {
        pAdvancedPage->m_hWnd = hWnd;
        pAdvancedPage->onInitDialog();
        return TRUE;
    }

    return FALSE;
}

PropPage::Item AdvancedPage::items[] = { { 0, 0, PropPage::T_END } };

AdvancedPage::ListItem AdvancedPage::listItems[] = {
	{ SettingsManager::GET_UPDATE_INFO, ResourceManager::SETCZDC_GET_DC_UPDATE },
	{ SettingsManager::MINIMIZE_ON_STARTUP, ResourceManager::SETTINGS_MINIMIZE_ON_STARTUP },
	{ SettingsManager::COMPRESS_TRANSFERS, ResourceManager::SETTINGS_COMPRESS_TRANSFERS },
	{ SettingsManager::AUTO_KICK, ResourceManager::SETTINGS_AUTO_KICK },
	{ SettingsManager::AUTO_KICK_NO_FAVS, ResourceManager::SETTINGS_AUTO_KICK_NO_FAVS },
	{ SettingsManager::TAB_COMPLETION, ResourceManager::SETTINGS_TAB_COMPLETION },
	{ SettingsManager::CLEAR_SEARCH, ResourceManager::SETTINGS_CLEAR_SEARCH },
	{ SettingsManager::FILTER_SEARCH, ResourceManager::SETCZDC_FILTER_SEARCH },
	{ SettingsManager::FREE_SLOTS_DEFAULT, ResourceManager::SETTINGS_FREE_SLOT_DEFAULT },
	{ SettingsManager::SEARCH_ONLY_TTH, ResourceManager::SETTINGS_ONLY_TTH },
	{ SettingsManager::SEARCH_EXPAND_GROUPS, ResourceManager::SEARCH_EXPAND_GROUPS },
	{ SettingsManager::USE_EXTENSION_DOWNTO, ResourceManager::SETTINGS_USE_EXTENSION_DOWNTO },
	{ SettingsManager::SETTINGS_USE_CTRL_FOR_LINE_HISTORY, ResourceManager::SETTINGS_USE_CTRL_FOR_LINE_HISTORY },
	{ SettingsManager::AUTO_AWAY, ResourceManager::SETTINGS_AUTO_AWAY },
	{ SettingsManager::AUTO_FOLLOW, ResourceManager::SETTINGS_AUTO_FOLLOW },
	{ SettingsManager::ADLS_BREAK_ON_FIRST, ResourceManager::SETTINGS_ADLS_BREAK_ON_FIRST },
	{ SettingsManager::LIST_DUPES, ResourceManager::SETTINGS_LIST_DUPES },
	{ SettingsManager::URL_HANDLER, ResourceManager::SETTINGS_URL_HANDLER },
	{ SettingsManager::MAGNET_REGISTER, ResourceManager::SETTINGS_URL_MAGNET },
	{ SettingsManager::SEND_UNKNOWN_COMMANDS, ResourceManager::SETTINGS_SEND_UNKNOWN_COMMANDS },
	{ SettingsManager::KEEP_LISTS, ResourceManager::SETTINGS_KEEP_LISTS },
	{ SettingsManager::TTH_LISTS, ResourceManager::SETTINGS_TTH_LISTS },
	{ SettingsManager::TTH_CHECK, ResourceManager::SETCZDC_TTH_CHECK },
	{ SettingsManager::SFV_CHECK, ResourceManager::SETTINGS_SFV_CHECK },
	{ SettingsManager::HUB_USER_COMMANDS, ResourceManager::SETTINGS_HUB_USER_COMMANDS },
	{ SettingsManager::SEARCH_PASSIVE, ResourceManager::SETCZDC_PASSIVE_SEARCH },
	{ SettingsManager::SHOW_SHARE_CHEAT, ResourceManager::SETCZDC_SHARE_CHEAT },
	{ SettingsManager::REPORT_DOWNLOAD, ResourceManager::SETCZDC_REPORT_DOWNLOAD },
	{ SettingsManager::REPORT_UPLOAD, ResourceManager::SETCZDC_REPORT_UPLOAD },
	{ SettingsManager::ADD_FINISHED_INSTANTLY, ResourceManager::SETTINGS_ADD_FINISHED_INSTANTLY },
	{ SettingsManager::MAGNET_ASK, ResourceManager::SETTINGS_MAGNET_ASK },
	{ SettingsManager::GARBAGE_COMMAND_INCOMING, ResourceManager::GARBAGE_INCOMING },
	{ SettingsManager::GARBAGE_COMMAND_OUTGOING, ResourceManager::GARBAGE_OUTGOING },
	{ SettingsManager::NO_SEG_UP, ResourceManager::SETTINGS_NO_SEG_UP },
	{ SettingsManager::IP_IN_CHAT, ResourceManager::SETTINGS_IP_IN_CHAT },
	{ SettingsManager::SHOW_SHELL_MENU, ResourceManager::SETTINGS_SHOW_SHELL_MENU },
	{ 0, ResourceManager::SETTINGS_AUTO_AWAY }
};

void AdvancedPage::onInitDialog() {
	PropPage::read(m_hWnd, items, listItems, ::GetDlgItem(m_hWnd, IDC_ADVANCED_BOOLEANS));
}

void AdvancedPage::write() {
	PropPage::write(m_hWnd, items, listItems, ::GetDlgItem(m_hWnd, IDC_ADVANCED_BOOLEANS));
}

/*
 * Some parts Copyright (C) 2002-2011 Petr Kozelka, PPK at czdc dot org
 * Licensed under GNU General Public License version 3.
 */
