/*
 * Copyright (C) 2001-2011 Jacek Sieka, arnetheduck on gmail point com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef FAVORITE_DIRS_PAGE_H
#define FAVORITE_DIRS_PAGE_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "PropPage.h"
#include "ExListViewCtrl.h"
#include "WinUtil.h"

class FavoriteDirsPage : public PropPage {
public:
	FavoriteDirsPage(SettingsManager *s);
	~FavoriteDirsPage();

	void onInitDialog();
	void onDropFiles(WPARAM wParam);
	void onItemchangedDirectories(LPNMHDR pnmh);
	bool onKeyDown(LPNMHDR pnmh);
	void onDoubleClick(LPNMHDR pnmh);
	void onClickedAdd();
	void onClickedRemove();
	void onClickedRename();

	// Common PropPage interface
	PROPSHEETPAGE *getPSP() { return &m_psp; }
	void write();
private:
	static TextItem texts[];
	ExListViewCtrl ctrlDirectories;
	TCHAR* title;

	void addDirectory(const tstring& aPath);

    static BOOL CALLBACK FavoriteDirsPageProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
};

#endif // FAVORITE_DIRS_PAGE_H

/*
 * Some parts Copyright (C) 2002-2011 Petr Kozelka, PPK at czdc dot org
 * Licensed under GNU General Public License version 3.
 */
